VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmMain 
   Caption         =   "BEUtilities Sample Application"
   ClientHeight    =   3435
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   9285
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   3435
   ScaleWidth      =   9285
   StartUpPosition =   2  'CenterScreen
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   288
      Top             =   3528
      _ExtentX        =   688
      _ExtentY        =   688
      _Version        =   393216
   End
   Begin VB.Frame Frame2 
      Caption         =   " File Transfer "
      Height          =   1452
      Left            =   36
      TabIndex        =   7
      Top             =   1908
      Width           =   9156
      Begin VB.CommandButton cmdStart 
         Caption         =   "&Start"
         Height          =   408
         Left            =   7524
         TabIndex        =   18
         Top             =   180
         Width           =   984
      End
      Begin VB.CommandButton cmdBrowseDestination 
         Caption         =   "..."
         Height          =   300
         Left            =   8604
         TabIndex        =   17
         Top             =   1008
         Width           =   300
      End
      Begin VB.CommandButton cmdBrowseSource 
         Caption         =   "..."
         Height          =   300
         Left            =   8604
         TabIndex        =   16
         Top             =   612
         Width           =   300
      End
      Begin VB.TextBox txtDestination 
         Height          =   288
         Left            =   1260
         TabIndex        =   15
         Top             =   1008
         Width           =   7284
      End
      Begin VB.TextBox txtSourceFile 
         Height          =   288
         Left            =   1260
         TabIndex        =   14
         Top             =   612
         Width           =   7284
      End
      Begin VB.CheckBox checkForceOverwrite 
         Caption         =   "Force Overwrite"
         Height          =   228
         Left            =   4860
         TabIndex        =   11
         Top             =   360
         Width           =   1980
      End
      Begin VB.OptionButton optionCopyAndDelete 
         Caption         =   "Copy and Delete"
         Height          =   264
         Left            =   3168
         TabIndex        =   10
         Top             =   324
         Value           =   -1  'True
         Width           =   1560
      End
      Begin VB.OptionButton optionMove 
         Caption         =   "Move"
         Height          =   300
         Left            =   2196
         TabIndex        =   9
         Top             =   288
         Width           =   876
      End
      Begin VB.OptionButton optionCopy 
         Caption         =   "Copy"
         Height          =   336
         Left            =   1296
         TabIndex        =   8
         Top             =   252
         Width           =   840
      End
      Begin VB.Label lblDestination 
         Caption         =   "Destination"
         Height          =   192
         Left            =   180
         TabIndex        =   13
         Top             =   1044
         Width           =   984
      End
      Begin VB.Label lblSourceFile 
         Caption         =   "Source File:"
         Height          =   192
         Left            =   180
         TabIndex        =   12
         Top             =   648
         Width           =   984
      End
   End
   Begin VB.Frame Frame1 
      Caption         =   " NT Event Logging "
      Height          =   1776
      Left            =   36
      TabIndex        =   0
      Top             =   72
      Width           =   9192
      Begin VB.CommandButton cmdWrite 
         Caption         =   "&Write"
         Enabled         =   0   'False
         Height          =   408
         Left            =   7884
         TabIndex        =   5
         Top             =   612
         Width           =   984
      End
      Begin VB.TextBox txtEventMessage 
         Height          =   300
         Left            =   1512
         TabIndex        =   4
         Top             =   1044
         Width           =   7392
      End
      Begin VB.OptionButton optionError 
         Caption         =   "Error"
         Height          =   264
         Left            =   216
         TabIndex        =   3
         Top             =   1116
         Width           =   840
      End
      Begin VB.OptionButton optionWarning 
         Caption         =   "Warning"
         Height          =   192
         Left            =   216
         TabIndex        =   2
         Top             =   828
         Width           =   1020
      End
      Begin VB.OptionButton optionInformation 
         Caption         =   "Information"
         Height          =   300
         Left            =   216
         TabIndex        =   1
         Top             =   432
         Width           =   1524
      End
      Begin VB.Label lblEventMessage 
         Caption         =   "Event Message"
         Height          =   264
         Left            =   1512
         TabIndex        =   6
         Top             =   756
         Width           =   1956
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Ensure BEUtilities.dll is in your System32 directory or a directory in your environment path.
Private Declare Function EventLogRegisterApp Lib "BEUtilities.dll" (ByVal szApplication As String) As Boolean
Private Declare Function EventLogWrite Lib "BEUtilities.dll" (ByVal lType As Long, ByVal szAppTitle As String, ByVal szMessage As String) As Long
Private Declare Function FileTransferVB Lib "BEUtilities.dll" (ByVal szSourceFile As String, ByVal szDestinationPath As String, ByVal szParam3 As String, ByVal szParam4 As String, ByVal szParam5 As String, ByVal lRetryVal As Long, ByVal lTimeOutVal As Long, ByVal lTransferMode As Long, ByVal lFailIfExist As Long, ByVal lRetryDwell As Long) As Long

Private Enum TransferMode
    COPY_FILE = 1
    MOVE_FILE = 2
    COPY_DELETE = 3 'will copy the file and if successful delete the original (recommended)
End Enum

Private Enum OverwriteType
    NO_OVERWRITE = 0
    OVERWRITE_FILE = 1
End Enum

Private m_bStopExit As Boolean 'if true, the app can exit. Prevent exit during file transfer
Private m_bRegisterInit As Boolean

Private Sub cmdBrowseDestination_Click()
Call SelectDirectory
End Sub
'******************************************
'* This function uses the common dialog control to select a file
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       02/Nov/2005
'******************************************
Private Sub SelectSourceFile()

On Error GoTo EH_SelectSourceFile

  CommonDialog1.CancelError = True ' Set CancelError is True
  CommonDialog1.Flags = cdlOFNHideReadOnly ' Set flags
  CommonDialog1.Filter = "All Files (*.*)|*.*|Text Files" ' Set filters
  CommonDialog1.FilterIndex = 2 ' Specify default filter
  CommonDialog1.ShowOpen ' Display the Open dialog box
  
  txtSourceFile.Text = CommonDialog1.FileName

NormalExit_SelectSourceFile:
    On Error GoTo 0
    Exit Sub

EH_SelectSourceFile:
    Err.Clear
    Resume NormalExit_SelectSourceFile

Resume_SelectSourceFile:
    Err.Clear
    Resume Next

End Sub
'******************************************
'* This function uses the common dialog control to select a directory
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       02/Nov/2005
'******************************************
Private Sub SelectDirectory()
Dim n_iLen As Integer
    
    '-- Cheap way to use the common dialog box as a directory-picker
    n_iLen = 3

On Error GoTo Resume_SelectDirectory

    CommonDialog1.Flags = cdlOFNPathMustExist
    CommonDialog1.Flags = CommonDialog1.Flags Or cdlOFNHideReadOnly
    CommonDialog1.Flags = CommonDialog1.Flags Or cdlOFNNoChangeDir
    CommonDialog1.Flags = CommonDialog1.Flags Or cdlOFNExplorer
    CommonDialog1.Flags = CommonDialog1.Flags Or cdlOFNNoValidate
    CommonDialog1.FileName = "*.*"

    CommonDialog1.CancelError = True        'do not terminate on error

    On Error Resume Next         'I will hande errors

    CommonDialog1.Action = 1              'Present "open" dialog

    '-- If FileTitle is null, user did not override the default (*.*)
    If CommonDialog1.FileTitle <> "" Then n_iLen = Len(CommonDialog1.FileTitle)

    If Err = 0 Then
        ChDrive CommonDialog1.FileName
        txtDestination.Text = Left(CommonDialog1.FileName, Len(CommonDialog1.FileName) - n_iLen)
    Else
      '-- User pressed "Cancel"
    End If


NormalExit_SelectDirectory:
    On Error GoTo 0
    Exit Sub

Resume_SelectDirectory:
    Err.Clear
    Resume Next

End Sub

Private Sub cmdBrowseSource_Click()
Call SelectSourceFile
End Sub

Private Sub cmdStart_Click()
Call TransferFile
End Sub

Private Sub cmdWrite_Click()
Call LogEvent
End Sub

Private Sub Form_Load()
m_bStopExit = False
m_bRegisterInit = False
End Sub

Private Sub Form_Unload(Cancel As Integer)
If m_bStopExit Then Cancel = 1
End Sub
'******************************************
'* This function writes a message to the NT event log
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       30/Oct/2005
'******************************************
Private Sub LogEvent()
Dim n_lRetVal As Long, n_lLogType As Long
Dim n_strMessage As String

On Error GoTo EH_LogEvent

If Not m_bRegisterInit Then
    m_bRegisterInit = True 'only register once
    
    'register the application to BEUtilities so we can write to the NT event log as required
    n_lRetVal = EventLogRegisterApp(App.Title)
    If n_lRetVal <> 0 Then GoTo NormalExit_LogEvent 'zero means success
End If

n_strMessage = txtEventMessage.Text

If optionError.Value = True Then n_lLogType = 1
If optionWarning.Value = True Then n_lLogType = 2
If optionInformation.Value = True Then n_lLogType = 4

'Write the message to the NT event log
Call EventLogWrite(n_lLogType, App.Title, n_strMessage)

NormalExit_LogEvent:
    On Error GoTo 0
    Exit Sub

EH_LogEvent:
    n_strMessage = "Function LogEvent failed with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_LogEvent

End Sub

Private Sub optionError_Click()
cmdWrite.Enabled = True
End Sub

Private Sub optionInformation_Click()
cmdWrite.Enabled = True
End Sub

Private Sub optionWarning_Click()
cmdWrite.Enabled = True
End Sub
'******************************************
'* This function transfers a file using BEUtilities
'* Input:      Lots. Hopefully, the names are self-explanatory
'* Output:     true if file transfer is successful
'* Programmer: MBevan
'* Date:       04/Nov/2005
'******************************************
Private Function TransferFile() As Boolean

Dim n_bReturnValue As Boolean
Dim n_lReturn As Long, n_lWatchdogTimeoutValue As Long
Dim n_lRetryAttempts As Long, n_lWaitBeforeRetry As Long
Dim n_strMessage As String, n_strSourceFile As String, n_strDestinationFile As String
Dim n_strBaseName As String, n_strDestinationPath As String
Dim n_TransferMode As TransferMode
Dim n_OverwriteType As OverwriteType
Dim n_FileSystemObject As FileSystemObject 'use the scrrun scripting tool

On Error GoTo EH_TransferFile
n_bReturnValue = False
n_OverwriteType = NO_OVERWRITE
n_TransferMode = COPY_DELETE
n_strMessage = ""

    Set n_FileSystemObject = New FileSystemObject

    'set all the parameters needed for the DLL
    n_strSourceFile = Trim(txtSourceFile.Text)
    n_strDestinationPath = Trim(txtDestination.Text)
    n_lRetryAttempts = 3 'attempt the transfer 3 times before returnng a failure
    n_lWatchdogTimeoutValue = 300 'wait for 300 seconds before timing out and trying again/failing
    n_lWaitBeforeRetry = 5 'wait 5 seconds before trying again
        
    If optionCopy.Value = True Then n_TransferMode = COPY_FILE
    If optionMove.Value = True Then n_TransferMode = MOVE_FILE
    If optionCopyAndDelete.Value = True Then n_TransferMode = COPY_DELETE
    
    n_OverwriteType = checkForceOverwrite.Value
    
    'build the destination file name
    n_strBaseName = n_FileSystemObject.GetFileName(n_strSourceFile)
    If Right(n_strDestinationPath, 1) <> "\" Then n_strDestinationFile = n_strDestinationFile & "\"
    n_strDestinationFile = n_strDestinationPath & n_strBaseName
    
    Me.MousePointer = vbHourglass 'set the hourglass to show we're busy
    Call SetControlStatus(False) 'disable the file transfer controls
    
    n_lReturn = FileTransferVB(n_strSourceFile, n_strDestinationFile, vbNull, vbNull, vbNull, _
              n_lRetryAttempts, n_lWatchdogTimeoutValue, n_TransferMode, n_OverwriteType, n_lWaitBeforeRetry)
    
    Me.MousePointer = vbDefault 'restore the mouse pointer
    Call SetControlStatus(True) 're-enable the file transfer controls
    
    Select Case n_lReturn
        Case 0
            n_bReturnValue = True
        Case 1
            n_strMessage = "Failed to transfer file. Bad Source File Name"
        Case 2
            n_strMessage = "Failed to transfer file. Bad Destination File Name"
        Case 3
            n_strMessage = "Failed to transfer file. Invalid Transfer Mode"
        Case 4
            n_strMessage = "Failed to transfer file. Retry Limit Too High."
        Case 5
            n_strMessage = "Failed to transfer file. Source File Does Not Exist."
        Case 6
            n_strMessage = "Failed to transfer file. Unknown File Transfer Error. Check the NT Event log for details"
        Case Else
            n_strMessage = "Failed to transfer file. Invalid response from BEUtilities"
    End Select

    If Not n_bReturnValue Then
        If Len(n_strMessage) > 0 Then 'if the length is greater than zero, we've failed
            Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
        Else
            n_strMessage = "Failed to transfer file for an unknown reason. Check the NT Event log for details."
            Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
        End If
    Else
        Call MsgBox("File transfer successful", vbOKOnly + vbInformation, "System Message")
    End If
    
NormalExit_TransferFile:
    On Error GoTo Resume_TransferFile
    
    'just in case something errored
    Me.MousePointer = vbDefault
    Call SetControlStatus(True)
    
    If Not n_FileSystemObject Is Nothing Then Set n_FileSystemObject = Nothing
    TransferFile = n_bReturnValue
    
    On Error GoTo 0
    Exit Function

EH_TransferFile:
    n_strMessage = "TransferFile function failed with error: " & Error()
    Call MsgBox(n_strMessage, vbOKOnly + vbCritical, "System Message")
    Err.Clear
    Resume NormalExit_TransferFile

Resume_TransferFile:
    Err.Clear
    Resume Next
    
End Function

'******************************************
'* This function enables/disables misc screen controls
'* Input:      None
'* Output:     None
'* Programmer: MBevan
'* Date:       05/Nov/2005
'******************************************
Private Sub SetControlStatus(bState As Boolean)

On Error GoTo Resume_SetControlStatus

optionCopy.Enabled = bState
optionMove.Enabled = bState
optionCopyAndDelete.Enabled = bState
checkForceOverwrite.Enabled = bState
cmdStart.Enabled = bState
cmdBrowseSource.Enabled = bState
cmdBrowseDestination.Enabled = bState
txtSourceFile.Enabled = bState
txtDestination.Enabled = bState

NormalExit_SetControlStatus:
    On Error GoTo 0
    Exit Sub

Resume_SetControlStatus:
    Err.Clear
    Resume Next

End Sub
